/*
 Super Duper Telecom Utility (sdtu)
 (C) 2000-2001 Grafixoft Email a@oo.ms 
 see file COPYRIGHT for info

*/

#define SDTUROOT

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <alloca.h>
#include <string.h>
#include <sys/types.h>
#include <signal.h>
#include <errno.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <sys/ioctl.h>
#include <netdb.h>
#include <fcntl.h>
#include <sys/file.h>
#include <arpa/inet.h>
#include <netinet/tcp.h>
#include <linux/soundcard.h>
#include <dirent.h>
#include "sdtu.h"

#define PORT 3666
/* start off in mono mode */
#define INITIALMODE 0x03

/*

FIONREAD

Audio formats:

AFMT_MU_LAW     MuLAW
AFMT_A_LAW      ALAW
AFMT_IMA_ADPCM  ADPCM
AFMT_MPEG       MPEG (2) audio


AFMT_S16_BE     Big endian signed 16
AFMT_U16_BE     Big endian U16

SUPPORTED NOW!
0x01 AFMT_S8         signed 8 (not tested)
0x02 AFMT_U8         unsigned 8
0x03 AFMT_U16_LE     Little endian U16 (not tested)
0x04 AFMT_S16_LE     Little endian signed 16



*/


/* assume 1500 mtu on net device, 50k max buffer. Watermark at 20k and 40k.
 Assume 4 samples always = one sample to keep stuff simple */


int tcpbufsize=0;
int onfile=0;
int onepacksize=0;
int lowwater=0;
int timeslow=0;
int dsplocked=0;
int highest=0;
int highlock=0;
int lowest=0;
int pkchk=0;
int breaklock=0;
int lastdir=0;
int kernelbad=1;
int dspqueueout=0;
int latency=300;

#define DROP_AT 10
/* .5 seconds @ 8Khz */
#define WATER_LEVEL 30

void problemo (char *string)
{
	
	if(sock && (onfile==0)) { 
		/* send the remote an abort signal */
		write(sock,"\000",1);
		sleep(2);
		shutdown(sock,0);
		close(sock); 
	}
	if(onfile!=0) close (sock);
	tcsetattr(0, TCSANOW, &tty_old);
	fprintf(stderr,"\r\n%s\r\n",string);
	exit(-1);
}




int record(char *buffie, int size)
{
	int junk=0;
	int caca,tx=0;
	int droppage=0;
	int crack=0;
	int runavg=0;
	int snap=0;

	if(onfile == 0) {
		/* use only if on a network, not on a file */
		ioctl(sock, TIOCOUTQ, &tx);
		/*
		TIOCOUTQ
			Returns  the  amount  of  unsent data in the socket
			send queue in the passed integer value pointer.

		seems to report free space on 2.2, fixed in 2.4 --AJK
		
		*/
		if(kernelbad==0) {
			tx=tcpbufsize-tx;
			/* 
				regain this bad habbit :-) 
				I need to know REMAINING space, 
				not used space!!! -- AJK 
			*/
		}
		crack=tcpbufsize-tx;

		if(crack<11424 && (dsplocked==0 || dsplocked==3) ) {
				if(crack<8190) timeslow++;
				if(crack >3264) lowest=crack;
				if((crack >=11424) && (snap>crack)) snap=crack;
		} else {
				timeslow=0;
		}

		runavg=(lowest+(DROP_AT*onepacksize))/2;
		
		if((crack<=runavg) && (tcpbufsize!=tx) && dsplocked!=2) {
			highlock++;
			if(highlock>51 && dsplocked==0) dsplocked=1;
		} else {
			highlock=0;
			breaklock++;
			if(crack>highest) highest=crack;
			if(breaklock>5 && dsplocked==1) {
				dsplocked=0;
				breaklock=0;
			}
		}

		if(timeslow>50 && dsplocked!=1 && dsplocked!=2 ) {
			if(snap<3264) return(16); /* leaps and bounds! */
			if(snap<4896) return(8);
			if(snap<=8160) return(4);
			return(1);
		}

		if(crack > (DROP_AT*onepacksize) && dsplocked!=3) {
			lowwater++;
		} else {
			lowwater=0;
		}

		printf("\rprofile %i watermark %i dsplock %i low %i:%i high %i:%i avg %i LW %i           \r",crack,DROP_AT*onepacksize,dsplocked,lowest,timeslow,highlock,highest,runavg,lowwater);
		fflush(stdout);
		
		if((lowwater>WATER_LEVEL)||(tx<5000)) {
			droppage=size; /* lose 100%, should keep dsp happy  */
			for(junk=0;junk<droppage;junk+=caca) {
				caca=read(audiostream,buffie+junk,droppage-junk);
				if (caca < 0) return -1;
			}
			return(-1); /* keep dsp recorder happy... */
		}
	
	}
/* is the for loop really needed? */
	for(junk=0;junk<size;junk+=caca) {
		caca=read(audiostream,buffie+junk,size-junk);
		if (caca < 0) {
			printf("FATAL Error Reading DSP\r\n");
			/* 
			This is caused by 440BX chipsets, total crap chipset.
			basically this means we need to re-open the dsp :-(

			*/
			caca=size;
			
		}
	}
	return(0);
}

void play(char *buffie, int size,int width)
{
	int junk=0;
	int caca;
/* this was a bad idea... */
#ifdef BADIDEA_1
	int rx=0;
	int droppage=0;
	int i;
	int frame;
	char *source;
	if(onfile == 0) {
		ioctl(sock, FIONREAD, &rx);
		if(rx > tcpbufsize/2) {
			droppage=9; /* lose 10% */
			if(rx > tcpbufsize/1.5) droppage=8; /* lose 20% */
			if(rx > tcpbufsize/1.25) droppage=6; /* lose 40% */
			printf("\rDropping %i%% of samples, queue showed %i   \n",(10-droppage)*10,rx);
			/*
			drop samples here spread out over the entire sample base so it's not to noticable.
			8bit will suffer most, oh well. 
			
			we need to do this downsample _FAST_
			*/
			frame=droppage*((size/160)*width);
			source=buffie;
			for(i=0;i<(size-(10*width));i+=10*width) {
				write(audiostream,(void *)source,droppage*width);
				source+=10*width;
			}
		} else {
			write(audiostream,(void *)buffie,size);
		}
	} else {
			write(audiostream,(void *)buffie,size);
	}
#else
	/* check our frags, if we're low, add 300ms delay so we can comensate for latency */
	struct audio_buf_info *audios;
	char audiostr[sizeof(struct audio_buf_info)];
	
	/* 
		NOTE: a fragment can be MANY bytes long!
		This is OK because our packages are too... --AJK
	*/				

	audios=(struct audio_buf_info*)&audiostr[0];
	ioctl(audiostream, SNDCTL_DSP_GETOSPACE, audios);
	dspqueueout=audios->fragstotal-audios->fragments;
	if(dspqueueout<2) {
		usleep(latency*100); /* adapt to the line latency. */
	}
	printf("\rdspqueueout=%i, audios->fragstotal=%i audios->fragments=%i       \r",dspqueueout,audios->fragstotal,audios->fragments);
	fflush(stdout);

	for(junk=0;junk<size;junk+=caca) {
		caca=write(audiostream,buffie+junk,size-junk);
		if((dspqueueout<100) && (dspqueueout>3)) usleep(2); /* fairness sleep for a "good" queue count -- AJK */
		if (caca < 0) {
			problemo("FATAL Error Writing DSP");
			caca=size;
		}
	}
#endif

}


/* the question is.... is it better to do lumps or to do it in pieces... */

int record_blocks(char *buffie, int size, int audiotype)
{
	char *temp;
	char *csource, *cldest, *crdest;
	short *ssource, *sldest, *srdest;
	int i;
	int retval=0;
	
	if(audiotype <= 127 ) {
		if(audiotype < 3 ) {
			retval=record((void *)buffie, size*160);
		} else {
			retval=record((void *)buffie, size*320);
		}
	} else {
		/* deinterleve lrlrlrlr -> llllrrrr */
		if(audiotype < 0x83) {
			/* 8bit */
			/* temp=malloc(size*160); */
			temp=alloca(size*160);
			retval=record((void *)temp,size*160);
			if(retval==0) {
				csource=temp;
				cldest=buffie;
				crdest=buffie+(size*80);
				for(i=0;i<(size*80);i++) {
					*cldest=*csource;
					csource++;
					cldest++;
					*crdest=*csource;
					csource++;
					crdest++;
				}
				/* free(temp); */
			}
		} else {
			/* 16bit */
			/* temp=malloc(size*320); */
			temp=alloca(size*320);
			retval=record((void *)temp,size*320);
			if(retval==0) {
				ssource=(short *)temp;
				sldest=(short *)buffie;
				srdest=(short *)buffie+(size*80);
				for(i=0;i<(size*80);i++) {
					*sldest=*ssource;
					ssource++;
					*srdest=*ssource;
					ssource++;
					sldest++;
					srdest++;
				}
				/* free(temp); */
			}
		}
	}

	return(retval);
}

void play_blocks(char *buffie, int size, int audiotype)
{
	char *temp;
	char *cdest, *clsource, *crsource;
	short *sdest, *slsource, *srsource;
	int i;
	if(audiotype <= 127 ) {
		if(audiotype < 3 ) {
			play((void *)buffie, size*160,1);
		} else {
			play((void *)buffie, size*320,2);
		}
	} else {
		/* interleve  llllrrrr -> lrlrlrlr */
		if(audiotype < 0x83) {
			/* 8bit */
			/* temp=malloc(size*160); */
			temp=alloca(size*160);
			clsource=buffie;
			crsource=buffie+(size*80);
			cdest=temp;
			for(i=0;i<(size*80);i++) {
				*cdest=*clsource;
				cdest++;
				clsource++;
				*cdest=*crsource;
				cdest++;
				crsource++;
			}
			play((void *)temp,size*160,2);
			/* free(temp); */
		} else {
			/* 16bit */
			/* temp=malloc(size*320); */
			temp=alloca(size*320);
			slsource=(short *)buffie;
			srsource=(short *)buffie+(size*80);
			sdest=(short *)temp;
			for(i=0;i<(size*80);i++) {
				*sdest=*slsource;
				sdest++;
				*sdest=*srsource;
				sdest++;
				slsource++;
				srsource++;
			}
			play((void *)temp,size*320,4);
			/* free(temp); */
		}
	}
}

/* read in needed bytes for style */
int xencode(char *src, char *dest, int style, int paqs)
{
	int scp;
	char *duh;
	short *zippy;
	short *uhmm;
	int retval=0;
	duh=src;
	retval=record_blocks(duh,paqs,style);
	if(retval==0) {
		switch (style) {
			case 0x00:
				duh=src;
				zippy=(short *)dest;
				for(scp=0;scp<(paqs * 160);scp++) {
					*zippy=audio_u2s(*duh);
					duh++;
					zippy++;
				}
				break;
			
			case 0x01:
				/* plain s8bit linear */
				duh=src;
				zippy=(short *)dest;
				for(scp=0;scp<(paqs * 160);scp++) {
					*zippy=(*duh * 256);
					zippy++;
					duh++;
				}
				break;

			case 0x02:
				/* plain u8bit linear */
				duh=src;
				zippy=(short *)dest;
				for(scp=0;scp<(paqs * 160);scp++) {
					*zippy=((unsigned)*duh - 128) * 256;
					zippy++;
					duh++;
				}
				break;

			case 0x03:
				/* plain u16bitle linear mono */
				uhmm=(short *)src;
				zippy=(short *)dest;
				for(scp=0;scp<(paqs * 320);scp++) {
					*zippy=((unsigned)*duh - 32768);
					zippy++;
					duh++;
				}
				break;

			case 0x04:
				/* plain s16bitle linear mono */
				bcopy(src,dest,paqs*320);
				break;

			case 0x83:
				/* plain u16bitle linear stereo */
				uhmm=(short *)src;
				zippy=(short *)dest;
				for(scp=0;scp<(paqs * 320);scp++) {
					*zippy=((unsigned)*duh - 32768);
					zippy++;
					duh++;
				}
				break;

			case 0x84:
				/* plain s16bitle linear stereo */
				bcopy(src,dest,paqs*320);
				break;

		}
			
	}
	return(retval);
}

/* decode and play */
void xdecode(char *src, char *dest, int style, int paqs)
{
	char *retbuf;
	short *srcbuf;
	short *sretbuf;
	int i;
	
	sretbuf=(short *)dest;
	retbuf=dest;
	srcbuf=(short *)src;

	switch (style) {
		case 0x00:
			/* ulaw_output */
			for (i=0; i<paqs*160; i++) {
				*retbuf=audio_s2u(*srcbuf);
				srcbuf++;
				retbuf++;
			}
			break;
		case 0x01:
			for (i=0; i<paqs*160; i++) {
				*retbuf=*srcbuf / 256;
				srcbuf++;
				retbuf++;
			}
			break;
		case 0x02:
			for (i=0; i<paqs*160; i++) {
				*retbuf=(*srcbuf / 256)+128;
				srcbuf++;
				retbuf++;
			}
			break;
		case 0x03:
			for (i=0; i<paqs*320; i++) {
				*sretbuf=*srcbuf + 32768;
				sretbuf++;
				srcbuf++;
			}
			break;
		case 0x04:
			bcopy(src,dest,paqs*320);
			break;

		case 0x83:
			for (i=0; i<paqs*320; i++) {
				*sretbuf=*srcbuf + 32768;
				sretbuf++;
				srcbuf++;
			}
			break;
		case 0x84:
			bcopy(src,dest,paqs*320);
			break;

		default:
			/* Duh? */
			break;
	}
	play_blocks(dest, paqs, style);
}


int recode(char *src, char *dest, int style, int data, int code)
{
	int retval=0;
	switch (code) {
		case 0:
			retval=xencode(src,dest,style,data);
			break;
		case 1:
			xdecode(src,dest,style,data);
			break;
		default: /* huh? */
			retval=-1;
			break;
	}
	return(retval);
}

void init_tty() {
	bcopy(&tty_old,&tty_new,sizeof(tty_new));


	tty_new.c_iflag |= IGNBRK;
	tty_new.c_lflag=0;


	tty_new.c_cflag &= ~(PARENB|CSIZE);	 /* Disable parity */
	tty_new.c_cflag |= (CREAD|CS8);     /* Set character size = 8 */
	tty_new.c_cc[VMIN]=1;
	tty_new.c_cc[VTIME]=100;	/* Produces warning. what value is 
					really needed? This mess needs to 
					be cleaned up! */
	tcsetattr(0, TCSANOW, &tty_new);

}


void cclosed(void)
{
	if(sock && (onfile==0)) { 
		/* send the remote an abort signal? */
		write(sock,"\000",1);
		sleep(2);
		shutdown(sock,0);
		close(sock); 
	}
	if(onfile==0) {	
		problemo("\r\nConnection closed by foreign host.");
	} else {
		close (sock);
		problemo("\r\nDone.");
	}
}

/*
buffer is FRAGMENT_BUFSIZE * 2 ^ FRAGMENT_BUFPOWER
eg.: 128 buffers (0x0080) of 64 (0x0006=2^6) bytes
arg = 0x00800006  ->  128 * 64 = 8192 bytes.
0x7fff0007 is the default?
*/
int openstream(int style,int way, int dspspeed)
{
	int dir=O_RDONLY;
	int i,j;
/*	int dspbufsize=7 | (32767<<16); */ /* piles o fragments, piles o packages :-) */
	int dspbufsize=10 | (4095<<16); /* piles o fragments, piles o packages :-) */

	timeslow=0;
	dsplocked=2;
	highest=0;
	highlock=0;
	lowwater=0;
	lowest=0;
	breaklock=0;

/*	if (onfile!=0) dspbufsize=14 | 4<<16; */
	printf("\r\nDSP speed request @ %iHz\n",dspspeed);
	switch (way) {
		case 1:
			dir=O_WRONLY;
			break;
		case 2:
			dir=O_RDWR;
			break;
	}
	if ((audiostream=open("/dev/dsp",dir))<0) { 
		perror("Error opening /dev/dsp"); 
		style=0;
	} else {
		ioctl(audiostream,SNDCTL_DSP_SETFRAGMENT,&dspbufsize);
		ioctl(audiostream, SNDCTL_DSP_RESET, 0);
		i=dspspeed;
		ioctl(audiostream,SNDCTL_DSP_SPEED, &i);
		i=(style&0x80)>>7;
		ioctl(audiostream, SNDCTL_DSP_STEREO, &i);
		ioctl(audiostream,SNDCTL_DSP_GETFMTS, &j);
	}

owch:
	i=j;

	switch (style & 0xff) {

		case 0:
			printf("\r\nWARNING! No supported dsp devices available\r\n");
			printf("\r\nTrying /dev/audio!\r\n");
			if ((audiostream=open("/dev/audio",dir))<0) {
				perror("emmm---");
				write(sock,"\000",1);
				problemo("\r\nNope!\r\nNo devices available\r\n");
			}
			ioctl(audiostream,SNDCTL_DSP_SETFRAGMENT,&dspbufsize);
			ioctl(audiostream, SNDCTL_DSP_RESET, 0);
			i=dspspeed;
			i=0;
			ioctl(audiostream, SNDCTL_DSP_STEREO, &i);
			ioctl(audiostream,SNDCTL_DSP_GETFMTS, &j);
			
			/* should probably make sure the format is something... */
			printf("Got it!\r\n");
			break;

		case 1: /* plain 8bit signed linear, dspspeed Hz, mono */
			if (i&=AFMT_S8) {
				ioctl(audiostream,SNDCTL_DSP_SETFMT, &i);
				printf("AFMT_S8\n");
			} else {
				close(audiostream);
				style--;
				goto owch;
			}
			break;

		case 2: /* plain 8bit unsigned linear, dspspeed Hz, mono */
			if (i&=AFMT_U8) {
				ioctl(audiostream,SNDCTL_DSP_SETFMT, &i);
				printf("AFMT_U8\n");
			} else {
				style--;
				goto owch;
			}
			break;

		case 3: /* plain 16bit unsigned linear, dspspeed Hz, mono, little endian */
			if (i&=AFMT_U16_LE) {
				ioctl(audiostream,SNDCTL_DSP_SETFMT, &i);
				printf("AFMT_U16_LE\n");
			} else {
				style--;
				goto owch;
			}
			break;

		case 4: /* plain 16bit signed linear, dspspeed Hz, mono, little endian */
			if (i&=AFMT_S16_LE) {
				ioctl(audiostream,SNDCTL_DSP_SETFMT, &i);
				printf("AFMT_S16_LE\n");
			} else {
				style--;
				goto owch;
			}
			break;

		case 0x83: /* plain 16bit unsigned linear, dspspeed Hz, stereo, little endian */
			if (i&=AFMT_U16_LE) {
				ioctl(audiostream,SNDCTL_DSP_SETFMT, &i);
				printf("AFMT_U16_LE, Stereo\n");
			} else {
				style--;
				goto owch;
			}
			break;

		case 0x84: /* plain 16bit signed linear, dspspeed Hz, stereo, little endian */
			if (i&=AFMT_S16_LE) {
				ioctl(audiostream,SNDCTL_DSP_SETFMT, &i);
				printf("AFMT_S16_LE, Stereo\n");
			} else {
				style--;
				goto owch;
			}
			break;

		default:
			style--;
			goto owch;
			break;
	}
	printf("\nBitrate: %6.2f\n",(float)((((dspspeed/1000)/2)*2)+((dspspeed/160)*33)) * (1+((style&0x80)>>7)));
	onepacksize=((((dspspeed/1000)/2)*2)+((dspspeed/160)*33)) * (1+((style&0x80)>>7)) ;
	if(DROP_AT*onepacksize > (tcpbufsize*.75)) {
		onepacksize=tcpbufsize*.75;
	}
	if (dspspeed>=42000) dsplocked=2;
	if(dspspeed<4500) dsplocked=3;
	pkchk=onepacksize*2;
	if(pkchk<1800) pkchk=1800;
	return(style);
}

unsigned long int resolver(char *host)
{
	int x=0;
	struct hostent *he;

	if(sscanf(host,"%d.%d.%d.%d",&x,&x,&x,&x)==4 || !strcmp(host,"0"))
		return(inet_addr(host));
	while(!(he=gethostbyname((char *)host)) && x++<3)
		sleep(1);
	if(x<3)
		return(htonl((unsigned long int)
			((unsigned char)he->h_addr_list[0][0]*
			(unsigned int)256+(unsigned char)he->h_addr_list[0][1])*
 			(unsigned int)65536+
 			(unsigned long int)((unsigned char)he->h_addr_list[0][2]*
 			(unsigned int)256+
 			(unsigned char)he->h_addr_list[0][3])));
	problemo("Unable to resolve host name.");
	return(-1);
}


struct sockaddr_in clt_addy;


/* init a socket... */				   
int receiver(int argc,char *argv[])
{
	int flag=1;
	struct sockaddr_in srv_addy;
	struct timeval tout;
	struct timeval mydelay;
	
	mydelay.tv_sec = 0;
	mydelay.tv_usec = 50000;
	tout.tv_sec=30;
	tout.tv_usec=0;
	
	tcgetattr(0, &tty_old);
	init_tty();

	if(!strcmp(argv[1],"F")) {
		tcpbufsize=1;
		sock=open(argv[2],O_WRONLY | O_CREAT | O_TRUNC,0666);
		printf("Recording %s...\n",argv[2]);
		onfile=1;
	} else {
		sock=socket(AF_INET, SOCK_STREAM, 0);
		bzero ((char *) &srv_addy.sin_addr.s_addr, sizeof(srv_addy.sin_addr.s_addr));
		srv_addy.sin_family=AF_INET;
		srv_addy.sin_port=htons((argc>=3 && atoi(argv[2])>0) ? atoi(argv[2]) : PORT);

		/* this should just wait... */
		write(fileno(stderr),"Waiting for socket...",21);

		setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &flag, sizeof(int));
	
		while(bind(sock, (struct sockaddr *)&srv_addy, sizeof(srv_addy))<0) {
			write(fileno(stderr), ".",1);
			sleep(2);
		} /* try to bind to address infinitely */

		/* 
		allow only *ONE* connection
		man getsockoptions(2) :-> mebby we could do some other crap
		and make it a tad more robust :-> 
		NOTE: you still have to tell new connects to SOD off :-)
		This is done by watching for a new socket connect, 
		and killing it on sight. I'll let you figgure it out :-><
		*/

		write(fileno(stderr),"Got it!\n",8);
	
		listen(sock, 1);
	
		sock=accept(sock, (struct sockaddr *)&clt_addy, &client_len);
		flag=1;
		/* speedup */
		setsockopt(sock,SOL_TCP,TCP_NODELAY,&flag, sizeof(int));
		printf("Someone has connected.\n");
		fflush(stdout);
		/* here is where we flag the kernel bug for the tx queue */
		ioctl(sock, TIOCOUTQ, &tcpbufsize);
		if(tcpbufsize==0) {
			kernelbad=0;
		}
		flag=sizeof(int);
		getsockopt(sock,SOL_SOCKET,SO_SNDBUF,&tcpbufsize, &flag);
		if(tcpbufsize!=65535) {
			printf("tcpbuf reported as %i, adjusting\n",tcpbufsize);
			tcpbufsize=65535;
			setsockopt(sock,SOL_SOCKET,SO_SNDBUF,&tcpbufsize, sizeof(int));
			getsockopt(sock,SOL_SOCKET,SO_SNDBUF,&tcpbufsize, &flag);
			if(tcpbufsize>65535) {
				printf("tcpbuf reported as %i, adjusting\n",tcpbufsize);
				tcpbufsize=32767;
				setsockopt(sock,SOL_SOCKET,SO_SNDBUF,&tcpbufsize, sizeof(int));
			}
		}
		getsockopt(sock,SOL_SOCKET,SO_SNDBUF,&tcpbufsize, &flag);
	}
	return(sock);
}


int transmiter(int argc, char *argv[])
{
	int flag=1;
	mydelay.tv_sec = 0;
	mydelay.tv_usec = 50000;
	
	tcgetattr(0, &tty_old);
	init_tty();

	setvbuf(stdin,NULL,_IONBF,0);
	setvbuf(stdout,NULL,_IONBF,0);

	if(!strcmp(argv[1],"P")) {
		tcpbufsize=1;
		sock=open(argv[2],O_RDONLY);
		printf("Playing %s...\n",argv[2]);
		onfile=1;
	} else {
		sock=socket(AF_INET,SOCK_STREAM,0);
		server.sin_family=AF_INET;
		server.sin_port=htons((argc>=4 && atoi(argv[3])>0) ? atoi(argv[3]) : PORT);
		server.sin_addr.s_addr=resolver(argv[2]);

		if(connect(sock,(struct sockaddr *)&server,sizeof(server))<0)
			problemo("Unable to connect to host.");
		/* speedup */
		setsockopt(sock,SOL_TCP,TCP_NODELAY,&flag, sizeof(int));
		printf("\r\nConnection to %s established, .5-2s lag added by some audio card drivers.\r\n",argv[2]);
		fflush(stdout);

		/* here is where we flag the kernel bug for the tx queue */
		ioctl(sock, TIOCOUTQ, &tcpbufsize);
		if(tcpbufsize==0) {
			kernelbad=0;
		}
		flag=sizeof(int);
		getsockopt(sock,SOL_SOCKET,SO_SNDBUF,&tcpbufsize, &flag);
		if(tcpbufsize!=65535) {
			printf("tcpbuf reported as %i, adjusting\n",tcpbufsize);
			tcpbufsize=65535;
			setsockopt(sock,SOL_SOCKET,SO_SNDBUF,&tcpbufsize, sizeof(int));
			getsockopt(sock,SOL_SOCKET,SO_SNDBUF,&tcpbufsize, &flag);
			if(tcpbufsize>65535) {
				printf("tcpbuf reported as %i, adjusting\n",tcpbufsize);
				tcpbufsize=32767;
				setsockopt(sock,SOL_SOCKET,SO_SNDBUF,&tcpbufsize, sizeof(int));
			}
		}
		getsockopt(sock,SOL_SOCKET,SO_SNDBUF,&tcpbufsize, &flag);

		bytes=0;
	}
	return(sock);
}


void usage(void)
{
	/* ajk was too lazy to write this so I did.. --Dan */
	printf("usage:\tsdtu T <hostname>\n");
	printf("\tsdtu R\n");
	printf("\tsdtu P <gsm audio file>\n");
	printf("\tsdtu F <file for gsm dump>\n");
	
	printf("\n\t^A - abort\n");
	printf("\t^I/tab - status report\n");
	printf("\t^X - toggle stereo/mono\n");
	printf("\t^U - increase dsp speed\n");
	printf("\t^Y - decrease dsp speed\n");
	printf("\t^B - reverse direction\n");

	exit(-1);
}


int main(int argc,char *argv[])
{

	char modus=2;
	int okay=0;
	int audiotype=INITIALMODE; /* this will auto adjust */
	
	/* 
		For 8 bit/mono boxes, emulate and downgrade in software.
		0x00 dspspeedKHz /dev/audio, ulaw 	1.7kbps stream
		0x01 dspspeedKHz /dev/dsp, 8bit linear	1.7kbps stream
		0x02 dspspeedKHz /dev/dsp, 16bit linear	1.7kbps stream
	*/
	signal(SIGPIPE,(void *)cclosed);
	signal(SIGCHLD,(void *)cclosed);
	signal(SIGHUP,(void *)cclosed);
	signal(SIGINT,(void *)cclosed);
	signal(SIGQUIT,(void *)cclosed);
	signal(SIGKILL,(void *)cclosed);


	if(argc<2) usage();
	if((!strcmp(argv[1],"R")) || (!strcmp(argv[1],"F"))) okay=receiver(argc,argv);
	if((!strcmp(argv[1],"T")) || (!strcmp(argv[1],"P"))) okay=transmiter(argc,argv);
	if((!strcmp(argv[1],"R")) || (!strcmp(argv[1],"F"))) modus=1;
	if((!strcmp(argv[1],"T")) || (!strcmp(argv[1],"P"))) modus=0;
	if (modus == 2) usage();
	if (okay==0) exit(1);
	
	if(onfile != 0) audiotype=0xfe;
		
	gsmh=gsm_create();
	hndle=gsm_create();
	printf("tcpbufsize=%i, kernalbugs=%i\n",tcpbufsize,kernelbad);
	for(;modus!=2;){
		switch(modus) {
			case 0:
				printf("\nRX MODE\n");
				modus=rx(audiotype);
				close(audiostream);
				break;
				
			case 1:
				printf("\nTX MODE\n");
				modus=tx(audiotype);
				close(audiostream);
				break;
				
			default:
				/* burp! */
				usage();
				break;
		}
	}
	printf("\nProgram terminated\n");
	exit(0); /* reached if user abandons */
}

